// Fig. 9.12: CommissionEmployee3.java
// A classe CommissionEmployee3 representa um empregado comissionado.

public class CommissionEmployee3
{
   private String firstName;                              
   private String lastName;                               
   private String socialSecurityNumber;                   
   private double grossSales; // vendas brutas semanais       
   private double commissionRate; // porcentagem da comisso

   // construtor de cinco argumentos
   public CommissionEmployee3( String first, String last, String ssn, 
      double sales, double rate )
   {
      // chamada implcita para o construtor Object ocorre aqui              
      firstName = first;
      lastName = last;
      socialSecurityNumber = ssn;
      setGrossSales( sales ); // valida e armazena as vendas brutas       
      setCommissionRate( rate ); // valida e armazena a taxa de comisso
   } // fim do construtor CommissionEmployee3 de cinco argumentos

   // configura o nome 
   public void setFirstName( String first )
   {
      firstName = first;
   } // fim do mtodo setFirstName 

   // retorna o nome
   public String getFirstName()
   {
      return firstName;
   } // fim do mtodo getFirstName

   // configura o sobrenome 
   public void setLastName( String last )
   {
      lastName = last;
   } // fim do mtodo setLastName 

   // retorna o sobrenome
   public String getLastName()
   {
      return lastName;
   } // fim do mtodo getLastName

   // configura o CIC 
   public void setSocialSecurityNumber( String ssn )
   {
      socialSecurityNumber = ssn; // deve validar
   } // fim do mtodo setSocialSecurityNumber

   // retorna o CIC
   public String getSocialSecurityNumber()
   {
      return socialSecurityNumber;
   } // fim do mtodo getSocialSecurityNumber 

   // configura a quantidade de vendas brutas
   public void setGrossSales( double sales )
   {
      grossSales = ( sales < 0.0 ) ? 0.0 : sales;
   } // fim do mtodo setGrossSales

   // retorna a quantidade de vendas brutas 
   public double getGrossSales()
   {
      return grossSales;
   } // fim do mtodo getGrossSales 

   // configura a taxa de comisso
   public void setCommissionRate( double rate )
   {
      commissionRate = ( rate > 0.0 && rate < 1.0 ) ? rate : 0.0;
   } // fim do mtodo setCommissionRate 

   // retorna a taxa de comisso 
   public double getCommissionRate()
   {
      return commissionRate;
   } // fim do mtodo getCommissionRate 

   // calcula os lucros                 
   public double earnings()
   {
      return getCommissionRate()*getGrossSales();
   } // fim do mtodo earnings              

   // retorna a representao String do objeto CommissionEmployee3
   public String toString()
   {
      return String.format( "%s: %s %s\n%s: %s\n%s: %.2f\n%s: %.2f", 
         "commission employee", getFirstName(),getLastName(), 
         "social security number", getSocialSecurityNumber(), 
         "gross sales", getGrossSales(), 
         "commission rate", getCommissionRate());
   } // fim do mtodo toString
} // fim da classe CommissionEmployee3 


/**************************************************************************
 * (C) Copyright 1992-2005 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/